BigInt -

# struct BigInt

- BigInt
- Int
- Number
- Value
- Object

## Overview

A `BigInt` can represent arbitrarily large integers.

It is implemented under the hood with GMP.

## Included Modules

- Comparable(Float)
- Comparable(BigInt)
- Comparable(UInt128 | UInt16 | UInt32 | UInt64 | UInt8)
- Comparable(Int128 | Int16 | Int32 | Int64 | Int8)

## Defined in:

## Constructors

- .new(str : String, base = 10)

  Creates a `BigInt` with the value denoted by str in the given base.

- .new(num : Int::Signed)

  Creates a `BigInt` from the given num.

- .new(num : Int::Unsigned)

  Creates a `BigInt` from the given num.

- .new(num : Float)

  Creates a `BigInt` from the given num.

- .new(num : BigInt)

  Returns num.

- .new

  Creates a `BigInt` with the value zero.

## Instance Method Summary

- #%(other : Int) : BigInt
- #&(other : Int) : BigInt
- #&*(other) : BigInt
- #&+(other) : BigInt
- #&-(other) : BigInt
- #*(other : BigInt) : BigInt
- #*(other : LibGMP::IntPrimitiveSigned) : BigInt
- #*(other : LibGMP::IntPrimitiveUnsigned) : BigInt
- #*(other : Int) : BigInt
- #**(other : Int) : BigInt
- #+(other : BigInt) : BigInt
- #+(other : Int) : BigInt
- #- : BigInt
- #-(other : BigInt) : BigInt
- #-(other : Int) : BigInt
- #/(other : Int) : BigInt

  DEPRECATED `BigInt#/` will return a `BigFloat` in 0.29.0. Use `BigInt#//` for integer division.

- #//(other : Int) : BigInt
- #<<(other : Int) : BigInt
- #<=>(other : BigInt)
- #<=>(other : Int::Signed)
- #<=>(other : Int::Unsigned)
- #<=>(other : Float)
- #>>(other : Int) : BigInt
- #^(other : Int) : BigInt
- #abs : BigInt
- #clone
- #digits : Array(Int32)
- #divmod(number : Int::Signed)
- #divmod(number : BigInt)
- #divmod(number : Int::Unsigned)
- #gcd(other : Int) : Int
- #gcd(other : BigInt) : BigInt
- #hash(hasher)

  TODO improve this

- #lcm(other : BigInt) : BigInt
- #lcm(other : Int) : BigInt
- #popcount
- #remainder(other : Int) : BigInt
- #tdiv(other : Int) : BigInt
- #to_big_f
- #to_big_i
- #to_f
- #to_f!
- #to_f32
- #to_f32!
- #to_f64
- #to_f64!
- #to_i
- #to_i!
- #to_i16
- #to_i16!
- #to_i32
- #to_i32!
- #to_i64
- #to_i64!
- #to_i8
- #to_i8!
- #to_s : String

  Returns a string representation of self.

- #to_s(base : Int) : String

  Returns a string containing the representation of big radix base (2 through 36).

- #to_s(io : IO) : Nil

  Returns a string representation of self.

- #to_u
- #to_u!
- #to_u16
- #to_u16!
- #to_u32
- #to_u32!
- #to_u64
- #to_u64!
- #to_u8
- #to_u8!
- #to_unsafe
- #trailing_zeros_count
- #unsafe_floored_div(other : Int) : BigInt
- #unsafe_floored_div(other : BigInt) : BigInt
- #unsafe_floored_divmod(number : BigInt)
- #unsafe_floored_divmod(number : LibGMP::ULong)
- #unsafe_floored_mod(other : Int) : BigInt
- #unsafe_floored_mod(other : BigInt) : BigInt
- #unsafe_truncated_div(other : Int) : BigInt
- #unsafe_truncated_div(other : BigInt) : BigInt
- #unsafe_truncated_divmod(number : BigInt)
- #unsafe_truncated_divmod(number : LibGMP::ULong)
- #unsafe_truncated_mod(other : Int) : BigInt
- #unsafe_truncated_mod(other : LibGMP::IntPrimitive) : BigInt
- #unsafe_truncated_mod(other : BigInt) : BigInt
- #|(other : Int) : BigInt
- #~ : BigInt

### Instance methods inherited from module `Comparable(Float)`

<(other : T) <, <=(other : T) <=, <=>(other : T) <=>, ==(other : T) ==, >(other : T) >, >=(other : T) >=

### Instance methods inherited from module `Comparable(BigInt)`

<(other : T) <, <=(other : T) <=, <=>(other : T) <=>, ==(other : T) ==, >(other : T) >, >=(other : T) >=

### Instance methods inherited from module `Comparable(UInt128 | UInt16 | UInt32 | UInt64 | UInt8)`

<(other : T | T | T | T | T) <, <=(other : T | T | T | T | T) <=, <=>(other : T | T | T | T | T) <=>, ==(other : T | T | T | T | T) ==, >(other : T | T | T | T | T) >, >=(other : T | T | T | T | T) >=

### Instance methods inherited from module `Comparable(Int128 | Int16 | Int32 | Int64 | Int8)`

<(other : T | T | T | T | T) <, <=(other : T | T | T | T | T) <=, <=>(other : T | T | T | T | T) <=>, ==(other : T | T | T | T | T) ==, >(other : T | T | T | T | T) >, >=(other : T | T | T | T | T) >=

### Instance methods inherited from struct `Int`

%(other : BigInt) : BigInt
%(other : Int) %, &*(other : BigInt) : BigInt &*, &**(exponent : Int) : self &**, &+(other : BigInt) : BigInt &+, &-(other : BigInt) : BigInt &-, *(other : BigInt) : BigInt
*(other : BigRational)
*(other : BigDecimal) *, **(exponent : Int) : self
**(exponent : Float) : Float64 **, +(other : BigRational)
+(other : BigDecimal)
+(other : BigInt) : BigInt +, -(other : BigRational)
-(other : BigInt) : BigInt
-(other : BigDecimal) -, /(other : BigRational)
/(other : BigDecimal)
/(other : Int)
/(other : BigInt) : BigInt /, //(other : Float)
//(other : BigRational)
//(other : BigDecimal)
//(other : BigInt) : BigInt
//(other : Int) //, <<(count : Int) <<, <=>(other : BigDecimal)
<=>(other : BigRational)
<=>(other : Int) : Int32
<=>(other : BigInt) <=>, ===(char : Char) ===, >>(count : Int) >>, abs abs, bit(bit) bit, bits_set?(mask) bits_set?, ceil ceil, chr chr, day : Time::Span day, days : Time::Span days, divisible_by?(num) divisible_by?, downto(to)
downto(to, &block : self -> ) : Nil downto, even? even?, fdiv(other) fdiv, floor floor, gcd(other : Int) gcd, gcm(other : BigInt) : Int gcm, hash(hasher) hash, hour : Time::Span hour, hours : Time::Span hours, humanize_bytes(io : IO, precision : Int = 3, separator = '.', *, significant : Bool = true, format : BinaryPrefixFormat = :IEC) : Nil
humanize_bytes(precision : Int = 3, separator = '.', *, significant : Bool = true, format : BinaryPrefixFormat = :IEC) : String humanize_bytes, lcm(other : BigInt) : BigInt
lcm(other : Int) lcm, microsecond : Time::Span microsecond, microseconds : Time::Span microseconds, millisecond : Time::Span millisecond, milliseconds : Time::Span milliseconds, minute : Time::Span minute, minutes : Time::Span minutes, modulo(other) modulo, month : Time::MonthSpan month, months : Time::MonthSpan months, nanosecond : Time::Span nanosecond, nanoseconds : Time::Span nanoseconds, odd? odd?, popcount popcount, pred pred, remainder(other : Int) remainder, round round, second : Time::Span second, seconds : Time::Span seconds, succ succ, tdiv(other : Int) tdiv, times
times(&block : self -> ) : Nil times, to(to)
to(to, &block : self -> ) : Nil to, to_big_d to_big_d, to_big_i : BigInt to_big_i, to_big_r to_big_r, to_io(io : IO, format : IO::ByteFormat) to_io, to_json(json : JSON::Builder) to_json, to_json_object_key to_json_object_key, to_s(io : IO) : Nil
to_s(base : Int, io : IO, upcase : Bool = false) : Nil
to_s(base : Int, upcase : Bool = false) : String
to_s : String to_s, trailing_zeros_count trailing_zeros_count, trunc trunc, upto(to)
upto(to, &block : self -> ) : Nil upto, week : Time::Span week, weeks : Time::Span weeks, year : Time::MonthSpan year, years : Time::MonthSpan years, ~ ~

### Constructor methods inherited from struct `Int`

from_io(io : IO, format : IO::ByteFormat) : self from_io

### Instance methods inherited from module `Comparable(BigDecimal)`

<(other : T) <, <=(other : T) <=, <=>(other : T) <=>, ==(other : T) ==, >(other : T) >, >=(other : T) >=

### Instance methods inherited from module `Comparable(BigRational)`

<(other : T) <, <=(other : T) <=, <=>(other : T) <=>, ==(other : T) ==, >(other : T) >, >=(other : T) >=

### Instance methods inherited from module `Comparable(BigInt)`

<(other : T) <, <=(other : T) <=, <=>(other : T) <=>, ==(other : T) ==, >(other : T) >, >=(other : T) >=

### Instance methods inherited from struct `Number`

*(other : Complex)
*(other : BigFloat) *, +(other : BigFloat)
+(other : Complex)
+ +, -(other : Complex)
-(other : BigFloat) -, /(other : Complex)
/(other : BigFloat) /, //(other : BigFloat) //, <=>(other : BigFloat)
<=>(other) : Int32? <=>, ==(other : Complex) ==, abs abs, abs2 abs2, cis cis, clamp(min, max)
clamp(range : Range) clamp, divmod(number) divmod, format(io : IO, separator = '.', delimiter = ',', decimal_places : Int? = nil, *, group : Int = 3, only_significant : Bool = false) : Nil
format(separator = '.', delimiter = ',', decimal_places : Int? = nil, *, group : Int = 3, only_significant : Bool = false) : String format, humanize(io : IO, precision = 3, separator = '.', delimiter = ',', *, base = 10 ** 3, significant = true, prefixes : Indexable = SI_PREFIXES) : Nil
humanize(precision = 3, separator = '.', delimiter = ',', *, base = 10 ** 3, significant = true, prefixes : Proc) : Nil
humanize(precision = 3, separator = '.', delimiter = ',', *, base = 10 ** 3, significant = true, &block) : String
humanize(io : IO, precision = 3, separator = '.', delimiter = ',', *, base = 10 ** 3, significant = true, &prefixes : Int32, Float64 -> Tuple(Int32, UNDERSCORE) | Tuple(Int32, UNDERSCORE, Bool)) : Nil
humanize(precision = 3, separator = '.', delimiter = ',', *, base = 10 ** 3, significant = true, prefixes = SI_PREFIXES) : String
humanize(io : IO, precision = 3, separator = '.', delimiter = ',', *, base = 10 ** 3, significant = true, prefixes : Proc) : Nil humanize, i i, round(digits = 0, base = 10) round, sign sign, significant(digits, base = 10) significant, step(*, to = nil, by = 1)
step(*, to = nil, by = 1, &block) step, to_big_f to_big_f, to_c to_c, to_yaml(yaml : YAML::Nodes::Builder) to_yaml, zero? : Bool zero?

### Constructor methods inherited from struct `Number`

zero : self zero

### Class methods inherited from struct `Number`

si_prefix(magnitude : Int, prefixes = SI_PREFIXES) : Char? si_prefix

### Instance methods inherited from module `Comparable(BigFloat)`

<(other : T) <, <=(other : T) <=, <=>(other : T) <=>, ==(other : T) ==, >(other : T) >, >=(other : T) >=

### Instance methods inherited from module `Comparable(Number)`

<(other : T) <, <=(other : T) <=, <=>(other : T) <=>, ==(other : T) ==, >(other : T) >, >=(other : T) >=

### Instance methods inherited from struct `Value`

==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup

### Instance methods inherited from class `Object`

!=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, class class, dup dup, hash(hasher)
hash hash, inspect(io : IO) : Nil
inspect : String inspect, itself itself, not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, tap(&block) tap, to_json(io : IO)
to_json to_json, to_pretty_json(indent : String = " ")
to_pretty_json(io : IO, indent : String = " ") to_pretty_json, to_s : String
to_s(io : IO) : Nil to_s, to_yaml(io : IO)
to_yaml to_yaml, try(&block) try, unsafe_as(type : T.class) forall T unsafe_as

### Constructor methods inherited from class `Object`

from_json(string_or_io, root : String) : self
from_json(string_or_io) : self from_json, from_yaml(string_or_io : String | IO) : self from_yaml

## Constructor Detail

def self.new(str : String, base = 10) #

Creates a `BigInt` with the value denoted by str in the given base.

Raises `ArgumentError` if the string doesn't denote a valid integer.

    require "big"

    BigInt.new("123456789123456789123456789123456789") # => 123456789123456789123456789123456789
    BigInt.new("123_456_789_123_456_789_123_456_789")  # => 123456789123456789123456789
    BigInt.new("1234567890ABCDEF", base: 16)           # => 1311768467294899695

def self.new(num : Int::Signed) #

Creates a `BigInt` from the given num.

def self.new(num : Int::Unsigned) #

Creates a `BigInt` from the given num.

def self.new(num : Float) #

Creates a `BigInt` from the given num.

def self.new(num : BigInt) #

Returns num. Useful for generic code that does `T.new(...)` with `T` being a `Number`.

def self.new #

Creates a `BigInt` with the value zero.

    require "big"

    BigInt.new # => 0

## Instance Method Detail

def %(other : Int) : BigInt #
def &(other : Int) : BigInt #
def &*(other) : BigInt #
def &+(other) : BigInt #
def &-(other) : BigInt #
def *(other : BigInt) : BigInt #
def *(other : LibGMP::IntPrimitiveSigned) : BigInt #
def *(other : LibGMP::IntPrimitiveUnsigned) : BigInt #
def *(other : Int) : BigInt #
def **(other : Int) : BigInt #
def +(other : BigInt) : BigInt #
def +(other : Int) : BigInt #
def - : BigInt #
def -(other : BigInt) : BigInt #
def -(other : Int) : BigInt #
def /(other : Int) : BigInt #

DEPRECATED `BigInt#/` will return a `BigFloat` in 0.29.0. Use `BigInt#//` for integer division.

def //(other : Int) : BigInt #
def <<(other : Int) : BigInt #
def <=>(other : BigInt) #
def <=>(other : Int::Signed) #
def <=>(other : Int::Unsigned) #
def <=>(other : Float) #
def >>(other : Int) : BigInt #
def ^(other : Int) : BigInt #
def abs : BigInt #
def clone #
def digits : Array(Int32) #
def divmod(number : Int::Signed) #
def divmod(number : BigInt) #
def divmod(number : Int::Unsigned) #
def gcd(other : Int) : Int #
def gcd(other : BigInt) : BigInt #
def hash(hasher) #

TODO improve this

def lcm(other : BigInt) : BigInt #
def lcm(other : Int) : BigInt #
def popcount #
def remainder(other : Int) : BigInt #
def tdiv(other : Int) : BigInt #
def to_big_f #
def to_big_i #
def to_f #
def to_f! #
def to_f32 #
def to_f32! #
def to_f64 #
def to_f64! #
def to_i #
def to_i! #
def to_i16 #
def to_i16! #
def to_i32 #
def to_i32! #
def to_i64 #
def to_i64! #
def to_i8 #
def to_i8! #
def to_s : String #

Returns a string representation of self.

    require "big"

    BigInt.new("123456789101101987654321").to_s # => 123456789101101987654321

def to_s(base : Int) : String #

Returns a string containing the representation of big radix base (2 through 36).

    require "big"

    BigInt.new("123456789101101987654321").to_s(8)  # => "32111154373025463465765261"
    BigInt.new("123456789101101987654321").to_s(16) # => "1a249b1f61599cd7eab1"
    BigInt.new("123456789101101987654321").to_s(36) # => "k3qmt029k48nmpd"

def to_s(io : IO) : Nil #

Returns a string representation of self.

    require "big"

    BigInt.new("123456789101101987654321").to_s # => 123456789101101987654321

def to_u #
def to_u! #
def to_u16 #
def to_u16! #
def to_u32 #
def to_u32! #
def to_u64 #
def to_u64! #
def to_u8 #
def to_u8! #
def to_unsafe #
def trailing_zeros_count #
def unsafe_floored_div(other : Int) : BigInt #
def unsafe_floored_div(other : BigInt) : BigInt #
def unsafe_floored_divmod(number : BigInt) #
def unsafe_floored_divmod(number : LibGMP::ULong) #
def unsafe_floored_mod(other : Int) : BigInt #
def unsafe_floored_mod(other : BigInt) : BigInt #
def unsafe_truncated_div(other : Int) : BigInt #
def unsafe_truncated_div(other : BigInt) : BigInt #
def unsafe_truncated_divmod(number : BigInt) #
def unsafe_truncated_divmod(number : LibGMP::ULong) #
def unsafe_truncated_mod(other : Int) : BigInt #
def unsafe_truncated_mod(other : LibGMP::IntPrimitive) : BigInt #
def unsafe_truncated_mod(other : BigInt) : BigInt #
def |(other : Int) : BigInt #
def ~ : BigInt #